// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#ifndef _APMESSAGEPARSER_H_INCLUDED_
#define _APMESSAGEPARSER_H_INCLUDED_

class IAPMessageReceiver;

class APMessageParser
{
private:
  enum { MAX_BUFFER=8192 };
  char m_aData[MAX_BUFFER];

  enum EState { PARSING_SIZE1, PARSING_SIZE2, PARSING_DATA };
  EState m_eState;
  unsigned m_nDataCount;

  union DwordBytes
  {
    unsigned long m_dword;
    unsigned char m_aBytes[4];
  };

  DwordBytes m_size1;
  DwordBytes m_size2;

  IAPMessageReceiver *m_pReceiver;

public:
  APMessageParser(IAPMessageReceiver *pReceiver)
    :
  m_eState(PARSING_SIZE1),
  m_nDataCount(0),
  m_pReceiver(pReceiver)
  {
  }

  bool PushChar(char ch);
};

#endif // _APMESSAGEPARSER_H_INCLUDED_
