// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#ifndef _APRECEIVE_H_INCLUDED_
#define _APRECEIVE_H_INCLUDED_

#include "APMessageParser.h"
#include "APDecodeEvents.h"

class IAPEvents;

// Accepts AP protocol data received from the server. It decodes 
// the messages received and invokes IAPEvents methods implemented
// by the client.
class APReceive
{
private:
  // Accepts data from server one character at a time and
  // calls IAPMessageReceiver method when a full packet
  // is detected.
  APMessageParser m_msgParser;
  APDecodeEvents  m_decoder;

public:
  APReceive(IAPEvents *pEvents);

  // Call this each time a character is received from the server.
  // When a full packet is received, the appropriate IAPEvents
  // method will be invoked.
  bool ParseChar(char ch);
};

#endif // _APRECEIVE_H_INCLUDED_
